# Class Clipboard

java.lang.Object
org.eclipse.swt.dnd.Clipboard

public class Clipboard extends Object
The `Clipboard` provides a mechanism for transferring data from one application to another or within an application.

IMPORTANT: This class is not intended to be subclassed.

Since:
  3.14

## Constructor Summary

Constructors
Constructor
Description
`Clipboard(Display display)`
Constructs a new instance of this class.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`checkSubclass()`
Checks that this class can be subclassed.
`protected void`
`checkWidget()`
Throws an `SWTException` if the receiver can not be accessed by the caller.
`void`
`dispose()`
Disposes of the operating system resources associated with the clipboard.
`Object`
`getContents(Transfer transfer)`
Retrieve the data of the specified type currently available on the system clipboard.
`boolean`
`isDisposed()`
Returns `true` if the clipboard has been disposed, and `false` otherwise.
`void`
`setContents(Object[] data, Transfer[] dataTypes)`
Place data of the specified type on the system clipboard.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Clipboard

public Clipboard(Display display)
Constructs a new instance of this class.

Parameters:
  `display` - the display on which to allocate the clipboard
Throws:
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  - `checkSubclass()`

## Method Details

### getContents

public Object getContents(Transfer transfer)
Retrieve the data of the specified type currently available on the system clipboard. Refer to the specific subclass of `Transfer` to determine the type of object returned. Only `TextTransfer` is currently supported.

The following snippet shows text being retrieved from the clipboard:

`

       Clipboard clipboard = new Clipboard(display);
       TextTransfer textTransfer = TextTransfer.getInstance();
       String textData = (String)clipboard.getContents(textTransfer);
       if (textData != null) System.out.println("Text is "+textData);

`

Parameters:
  `transfer` - the transfer agent for the type of data being requested
Returns:
  the data obtained from the clipboard or null if no data of this type is available
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if transfer is null
  `UnsupportedOperationException` - when running the application in JEE_COMPATIBILITY mode
  `IllegalStateException` - when clipboard content is already requested.
See Also:
  - `Application.OperationMode`
  - `Transfer`

### setContents

public void setContents(Object[] data, Transfer[] dataTypes)
Place data of the specified type on the system clipboard. Only one type of data can be placed on the system clipboard at the same time. Setting the data clears any previous data from the system clipboard, regardless of type. Only `TextTransfer` is currently supported.

The following snippet shows text being set on the copy/paste clipboard:

`

     Clipboard clipboard = new Clipboard(display);
     String textData = "Hello World";
     TextTransfer textTransfer = TextTransfer.getInstance();
     Transfer[] transfers = new Transfer[]{textTransfer};
     Object[] data = new Object[]{textData};
     clipboard.setContents(data, transfers);

`

Parameters:
  `data` - the data to be set in the clipboard
  `dataTypes` - the transfer agents that will convert the data to its platform specific format; each entry in the data array must have a corresponding dataType
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if data is null or datatypes is null or the length of data is not the same as the length of dataTypes
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  `SWTError` -
  - ERROR_CANNOT_SET_CLIPBOARD - if the clipboard is locked or otherwise unavailable
  `UnsupportedOperationException` - when running the application in JEE_COMPATIBILITY mode
  `IllegalStateException` - when clipboard content is already requested.
See Also:
  - `Application.OperationMode`

### dispose

public void dispose()
Disposes of the operating system resources associated with the clipboard. The data will still be available on the system clipboard after the dispose method is called.

Throws:
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent

### isDisposed

public boolean isDisposed()
Returns `true` if the clipboard has been disposed, and `false` otherwise.

This method gets the dispose state for the clipboard. When a clipboard has been disposed, it is an error to invoke any other method using the clipboard.

Returns:
  `true` when the widget is disposed and `false` otherwise

### checkWidget

protected void checkWidget()
Throws an `SWTException` if the receiver can not be accessed by the caller. This may include both checks on the state of the receiver and more generally on the entire execution context. This method should be called by widget implementors to enforce the standard SWT invariants.

Currently, it is an error to invoke any method (other than `isDisposed()`) on a widget that has had its `dispose()` method called. It is also an error to call widget methods from any thread that is different from the thread that created the widget.

In future releases of SWT, there may be more or fewer error checks and exceptions may be thrown for different reasons.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### checkSubclass

protected void checkSubclass()
Checks that this class can be subclassed.

The SWT class library is intended to be subclassed only at specific, controlled points. This method enforces this rule unless it is overridden.

IMPORTANT: By providing an implementation of this method that allows a subclass of a class which does not normally allow subclassing to be created, the implementer agrees to be fully responsible for the fact that any such subclass will likely fail between SWT releases and will be strongly platform specific. No support is provided for user-written classes which are implemented in this fashion.

The ability to subclass outside of the allowed SWT classes is intended purely to enable those not on the SWT development team to implement patches in order to get around specific limitations in advance of when those limitations can be addressed by the team. Subclassing should not be attempted without an intimate and detailed understanding of the hierarchy.

Throws:
  `SWTException` -
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass